{============================================================================}
unit Main;
{============================================================================}
{ ZipEject 1.3                                                               }
{                                                                            }
{ Small Tray-Tool which ejects the selected devices
{============================================================================}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, mmSystem, TrayIcon,
  mdURLLabel;

type
  TMainForm = class(TForm)
    TrayIcon1: TTrayIcon;
    PopupMenu1: TPopupMenu;
    ExitNoEject1: TMenuItem;
    ExitEject1: TMenuItem;
    ZipEject1: TMenuItem;
    C1996HansLuijten1: TMenuItem;
    N1: TMenuItem;
    function  EjectMedia(Drive: Char): Integer;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ExitNoEject1Click(Sender: TObject);
    procedure ExitEject1Click(Sender: TObject);
    procedure C1996HansLuijten1Click(Sender: TObject);
  end;

 type
   TIoCtlRegs = record
     EBX, EDX, ECX, EAX, EDI, ESI, Flags: DWORD;
     end;

var
  MainForm: TMainForm;

implementation

uses About;

{$R *.DFM}

function TMainForm.EjectMedia(Drive: Char): Integer;
 var                        { Special thanks to: Steve Schafer (TeamB) }
   VxD: THandle;            { He's the one that helped me with this    }
   Regs: TIoCtlRegs;        { and wrote this function !!               }
   Return: DWORD;
 begin
   { Create handle }
   VxD := CreateFile('\\.\VWIN32', 0, 0, nil, 0, FILE_FLAG_DELETE_ON_CLOSE, 0);
   { This will probably not work with WindowsNT }
   with Regs do
     begin
       EAX := $440D;
       EBX := Ord(UpCase(Drive)) - Ord('A') + 1; { assign drive letter }
       ECX := $0849;
       Flags := $0001;
     end;
   { Activate MediaEject }
   DeviceIOControl(VxD, 1, @Regs, SizeOf(Regs), @Regs, SizeOf(Regs), Return, nil);
   CloseHandle(VxD);   { Close handle }
   Result := Regs.EAX;
 end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Width:=0;
  Height:=0;
  Hide;

  TrayIcon1.Minimize;
  if ParamCount<1 then { did we get the parameter for the drive letter ? }
    begin                                                              { Nope: }
      { Some instructions and an error-message }
      MessageBox(Handle,'You did not set enough parameters !'+#13+#13+
                        '1. Make a shortcut to ZipEject.exe'+#13+
                        '2. Use Properties, ShortCut, Target'+#13+
                        '3. Add a space and a driveletter(s) AFTER the ZipEject.exe'+#13+#13+
                        'ie: "C:\Program Files\ZipEject\ZipEject.exe" D E F'+#13+#13+
                        'where "D", "E" and "F" are the devices you'+#39+'d like to eject on system shutdown',
               'ERROR - ZipEject v1.3', mb_Ok or mb_IconExclamation or mb_DefButton1);
      halt; { quit program }
    end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var tmp :string;
    cnt :integer;
begin
  for cnt:=1 to ParamCount do
    begin
      tmp:=ParamStr(cnt);   { Copy Parameter-string }
      EjectMedia(tmp[1]); { only first char for driveletter }
    end;
end;

procedure TMainForm.ExitNoEject1Click(Sender: TObject);
begin
  halt;
end;

procedure TMainForm.ExitEject1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.C1996HansLuijten1Click(Sender: TObject);
begin
  AboutDlg.ShowModal;
end;

end.
